//
// Label.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Label: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var mediaId: Int?
    public var name: String?
    public var classId: Int?
    public var confidence: Float?
    public var rank: Int?
    public var source: String?
    public var updatedAt: Date?
    public var createdAt: Date?
    public var media: Media?

    public init(id: Int? = nil, mediaId: Int? = nil, name: String? = nil, classId: Int? = nil, confidence: Float? = nil, rank: Int? = nil, source: String? = nil, updatedAt: Date? = nil, createdAt: Date? = nil, media: Media? = nil) {
        self.id = id
        self.mediaId = mediaId
        self.name = name
        self.classId = classId
        self.confidence = confidence
        self.rank = rank
        self.source = source
        self.updatedAt = updatedAt
        self.createdAt = createdAt
        self.media = media
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case mediaId
        case name
        case classId
        case confidence
        case rank
        case source
        case updatedAt
        case createdAt
        case media = "Media"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(mediaId, forKey: .mediaId)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encodeIfPresent(classId, forKey: .classId)
        try container.encodeIfPresent(confidence, forKey: .confidence)
        try container.encodeIfPresent(rank, forKey: .rank)
        try container.encodeIfPresent(source, forKey: .source)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(media, forKey: .media)
    }
}

